﻿<?php	
//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
abstract class Anwendung {
	
	//Eigenschaften: Attribute
	private $bezeichnung;	
	
	public function get_bezeichnung() {
		return $this->bezeichnung;
	}	
	
	public function set_bezeichnung($pBezeichnung) {
		$this->bezeichnung = $pBezeichnung;
	}
		
}


//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
abstract class Rechner extends Anwendung {
	
	//Eigenschaften: Attribute
	private $ergebnis;	

	public function get_ergebnis() {
		return $this->ergebnis;
	}	
	
	public function set_ergebnis($pErgebnis) {
		$this->ergebnis = $pErgebnis;
	}	
		
}//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
class Bmirechner extends Rechner{
	
	//Eigenschaften: Attribute
	private $gewicht;
	private $groesse;
	
	//Erweiterte Eigenschaften
	private $alter;
	private $geschlecht;
	private $kategorie;
	private $min;
	private $max;
	
	//Standard Konstruktor (ohne Parameter und leer): Zum erzeugen von Objekten einer Klasse
	public function __construct(){}
	
	//Getter: Get-Methoden ermitteln den Wert einer Eigenschaft eines Objektes der Klasse		
	public function get_gewicht() {
		return $this->gewicht;
	}
	
	public function get_groesse() {
		return $this->groesse;
	}
	
	
	public function get_alter() {
		return $this->alter;
	}
	
	public function get_geschlecht() {
		return $this->geschlecht;
	}
	
	public function get_kategorie() {
		return $this->kategorie;
	}	
	
	public function get_min() {
		return $this->min;
	}
	
	public function get_max() {
		return $this->max;
	}	
	
	//Setter: Get-Methoden übermitteln den Eigenschaftswert an ein Objektes der Klasse	
	public function set_gewicht($pGewicht) {
		$this->gewicht = $pGewicht;
	}
	
	public function set_groesse($pGroesse) {
		$this->groesse = $pGroesse;
	}
		
	
	public function set_alter($pAlter) {
		$this->alter = $pAlter;
	}
	
	public function set_geschlecht($pGeschlecht) {
		$this->geschlecht = $pGeschlecht;
	}
	
	public function set_kategorie($pKategorie) {
		$this->kategorie = $pKategorie;
	}
	
	public function set_min($pMin) {
		$this->min = $pMin;
	}
	
	public function set_max($pMax) {
		$this->max = $pMax;
	}
	
	//Verhaltensweisen: Sonstige Methoden
	public function berechne_bmi() {
		$mBmi = $this->get_gewicht()/($this->get_groesse() * $this->get_groesse());
		$this->set_ergebnis($mBmi);
	}
	
	//Erweiterte Verhaltensweisen
	public function interpretiere_bmi(){
		$mBmi = $this -> get_ergebnis();
		$mGeschlecht = $this -> get_geschlecht();
		if($mGeschlecht=="männlich"){
			if($mBmi > 40){
				$this -> set_kategorie("Starke Adipositas");
			}elseif($mBmi >= 31 && $mBmi <= 40){
				$this -> set_kategorie("Adipositas");
			}elseif($mBmi >= 26 && $mBmi <= 30){
				$this -> set_kategorie("&Uuml;bergewicht");
			}elseif($mBmi >= 20 && $mBmi <= 25){
				$this -> set_kategorie("Normalgewicht");
			}elseif($mBmi < 20){
				$this -> set_kategorie("Untergewicht");
			}else{
				$this -> set_kategorie("Nicht erfasst!");
			}
			
		}else{
			if($mBmi > 40){
				$this -> set_kategorie("Starke Adipositas");
			}elseif($mBmi >= 31 && $mBmi <= 40){
				$this -> set_kategorie("Adipositas");
			}elseif($mBmi >= 25 && $mBmi <= 30){
				$this -> set_kategorie("&Uuml;bergewicht");
			}elseif($mBmi >= 19 && $mBmi <= 24){
				$this -> set_kategorie("Normalgewicht");
			}elseif($mBmi < 19){
				$this -> set_kategorie("Untergewicht");
			}else{
				$this -> set_kategorie("Nicht erfasst!");
			}			
		}
	}
	
	public function bestimme_opt(){
		$mAlter = $this -> get_alter();
			if($mAlter > 65){
				$this -> set_min(19);
				$this -> set_max(24);
			}elseif($mAlter >=55 && $mAlter <= 64){
				$this -> set_min(23);
				$this -> set_max(28);
			}elseif($mAlter >=45 && $mAlter <= 54){
				$this -> set_min(22);
				$this -> set_max(27);
			}elseif($mAlter >=35 && $mAlter <= 44){
				$this -> set_min(21);
				$this -> set_max(26);
			}elseif($mAlter >=25 && $mAlter <= 34){
				$this -> set_min(20);
				$this -> set_max(25);
			}elseif($mAlter < 19 && $mAlter <= 24){
				$this -> set_min(19);
				$this -> set_max(24);
			}else{
				$this -> set_min(0);
				$this -> set_max(0);				
			}		
	}	
	
	
}

//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
class Notenrechner extends Rechner{
	private $mathe;
	private $deutsch;
	private $englisch;
	private $bwl;
	
	//Standard Konstruktor (ohne Parameter und leer): Zum erzeugen von Objekten einer Klasse
	public function __construct(){}
	
	//Getter: Get-Methoden ermitteln den Wert einer Eigenschaft eines Objektes der Klasse
	public function get_mathe() {
		return $this->mathe;
	}
		
	public function get_deutsch() {
		return $this->deutsch;
	}
	
	public function get_englisch() {
		return $this->englisch;
	}
	
	public function get_bwl() {
		return $this->bwl;
	}
	

	//Setter: Get-Methoden übermitteln den Eigenschaftswert an ein Objektes der Klasse	
	public function set_mathe($pMathe) {
		$this->mathe = $pMathe;
	}
	
	public function set_deutsch($pDeutsch) {
		$this->deutsch = $pDeutsch;
	}
	
	public function set_englisch($pEnglisch) {
		$this->englisch = $pEnglisch;
	}
	
	public function set_bwl($pBwl) {
		$this->bwl = $pBwl;
	}
		
	//Verhaltensweisen: Sonstige Methoden	
	public function berechne_durchschnitt() {
		$mDurchschnitt = ($this->get_mathe() + $this->get_deutsch() + $this->get_englisch() + $this->get_bwl())/ 4;
		$this->set_ergebnis($mDurchschnitt);
	}
}

//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
class Taschenrechner extends Rechner{
	private $zahl1;
	private $zahl2;
	private $operator;
	
	//Standard Konstruktor (ohne Parameter und leer): Zum erzeugen von Objekten einer Klasse
	public function __construct(){}
	
	public function set_zahl1($pZahl1) {
		$this->zahl1 = $pZahl1;
	}
	
	public function get_zahl1() {
		return $this->zahl1;
	}
	
	public function set_zahl2($pZahl2) {
		$this->zahl2 = $pZahl2;
	}
	
	public function get_zahl2() {
		return $this->zahl2;
	}
	
	public function set_operator($pOperator) {
		$this->operator = $pOperator;
	}
	
	public function get_operator() {
		return $this->operator;
	}
	
	public function addieren(){		
		/*Rechenoperator in 
		 * lokales Attribut übernehmen*/
		$mOperator = "+";
		
		//Berechnung definieren
		$pErgebnis =  $this->get_zahl1() 
				+ $this->get_zahl2();
		
		/*Operator und Ergebnis in das
		 * Objekt übermitteln*/
		$this->set_operator($mOperator);
		$this->set_ergebnis($pErgebnis);
	}
	
	public function subtrahieren(){
		$mOperator = "-";
		$pErgebnis =  $this->get_zahl1() - $this->get_zahl2();
		$this->set_operator($mOperator);
		$this->set_ergebnis($pErgebnis);
	}
	
	public function multiplizieren(){
		$mOperator = "*";
		$pErgebnis =  $this->get_zahl1() * $this->get_zahl2();
		$this->set_operator($mOperator);
		$this->set_ergebnis($pErgebnis);
	}
	
	public function dividieren(){
		$mOperator = "/";
		if($this->get_zahl2() == 0) {
			$mMeldung="Die Division durch 0 ist nicht erlaubt.<br /><br />";
			echo $mMeldung;
			$this->set_operator($mOperator);
			$this->set_ergebnis("Berechnung nicht m&ouml;glich!");
			
		}else{
			$pErgebnis =  $this->get_zahl1() / $this->get_zahl2();
			$this->set_operator($mOperator);
			$this->set_ergebnis($pErgebnis);
		}
	}
	
	public function potenzieren(){
		$mOperator = "^";
		$pErgebnis =   pow($this->get_zahl1(), $this->get_zahl2());
		$this->set_operator($mOperator);
		$this->set_ergebnis($pErgebnis);
	}
		
	public function berechne(){
		$mOperator = $this -> get_operator();
		switch ($mOperator) {
			case 1:
				$this->addieren();
				break;
			case 2:
				$this->subtrahieren();
				break;
			case 3:
				$this->multiplizieren();
				break;
			case 4:
				$this->dividieren();
				break;
			case 5:
				$this->potenzieren();
				break;
			default:
				$mMeldung ="Eingabefehler! Sie haben keine der möglichen Rechenoperationen gewählt!";
				echo $mMeldung."<br />Berechnung nicht möglich!!";
			$this->set_ergebnis(0);
			break;
		}
	}	
}

//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
class Rabattrechner extends Rechner{
	
	//Eigenschaften: Attribute
	private $betrag;
	private $menge;
	private $rabattsatz;
	private $rabattbetrag;
	private $zahlungsbetrag;
	
	//Standard Konstruktor (ohne Parameter und leer): Zum erzeugen von Objekten einer Klasse
	public function __construct(){}
	
	//Getter: Get-Methoden ermitteln den Wert einer Eigenschaft eines Objektes der Klasse		
	public function get_betrag() {
		return $this->betrag;
	}
	
	public function get_menge() {
		return $this->menge;
	}
	
	public function get_rabattsatz() {
		return $this->rabattsatz;
	}
	
	public function get_rabattbetrag() {
		return $this->rabattbetrag;
	}	
	
	public function get_zahlungsbetrag() {
		return $this->zahlungsbetrag;
	}
	
	//Setter: Get-Methoden übermitteln den Eigenschaftswert an ein Objektes der Klasse	
	public function set_betrag($pBetrag) {
		$this->betrag = $pBetrag;
	}
	
	public function set_menge($pMenge) {
		$this->menge = $pMenge;
	}
		
	public function set_rabattsatz($pRabattsatz) {
		$this->rabattsatz = $pRabattsatz;
	}
	
	public function set_rabattbetrag($pRabattbetrag) {
		$this->rabattbetrag = $pRabattbetrag;
	}	
	
	public function set_zahlungsbetrag($pZahlungsbetrag) {
		$this->zahlungsbetrag = $pZahlungsbetrag;
	}
		
	//Verhaltensweisen: Sonstige Methoden
	public function ermittle_rabattsatz() {
		$mMenge = $this -> get_menge();
		$mBettrag = $this -> get_betrag();
		
		if($mMenge>= 150  ){
			$this -> set_rabattsatz(0);	
		}elseif($mMenge >= 100 ){
			$this -> set_rabattsatz(10);
		}elseif($mMenge >= 50 ){
			$this -> set_rabattsatz(15);
		}elseif($mMenge >= 20){
			$this -> set_rabattsatz(20);
		}elseif($mMenge <= 20 ){
			$this -> set_rabattsatz(25);
		}else{
			$this -> set_rabattsatz(27);
		}
	}	
	
	public function berechne_rabattbetrag() {
		$mRabattbetrag = $this -> get_betrag()/100 * $this -> get_rabattsatz();
		$this -> set_rabattbetrag($mRabattbetrag);
	}
	
	public function berechne_zahlungsbetrag() {
		$mZahlungsbetrag = $this -> get_betrag() - $this -> get_rabattbetrag();
		$this -> set_zahlungsbetrag($mZahlungsbetrag);
	}	
	
	public function ermittle() {
		$this -> ermittle_rabattsatz();
		$this -> berechne_rabattbetrag();
		$this -> berechne_zahlungsbetrag();
	}	
		
}

//#################################################
//Eine Klasse: Vorlage für eine ganze Menge von Objekten
class Darlehnsrechner extends Rechner{
	
	//Eigenschaften: Attribute
	private $finanzierungsbedarf;
	private $zinssatz;
	private $tilgungssatz;
	private $zeitraum;
	private $jahr = 1;
	private $kreditbetrag;
	private $zinsanteil_jahr;
	private $tilgung_jahr;
	private $belastung_monat;
	private $belastung_jahr;
	private $kontostand_ende_jahr;
	private $summe_zinsanteile;
	
	//Standard Konstruktor (ohne Parameter und leer): Zum erzeugen von Objekten einer Klasse
	public function __construct(){}
	
	//Getter: Get-Methoden ermitteln den Wert einer Eigenschaft eines Objektes der Klasse		
	public function get_finanzierungsbedarf() {
		return $this->finanzierungsbedarf;
	}
	
	public function get_zinssatz() {
		return $this->zinssatz;
	}
	
	public function get_tilgungssatz() {
		return $this->tilgungssatz;
	}
	
	public function get_zeitraum() {
		return $this->zeitraum;
	}	
	
	public function get_jahr() {
		return $this->jahr;
	}

	public function get_kreditbetrag() {
		return $this->kreditbetrag;
	}

	public function get_zinsanteil_jahr() {
		return $this->zinsanteil_jahr;
	}

	public function get_tilgung_jahr() {
		return $this->tilgung_jahr;
	}
	
	public function get_belastung_monat() {
		return $this->belastung_monat;
	}
	
	public function get_belastung_jahr() {
		return $this->belastung_jahr;
	}
	
	public function get_kontostand_ende_jahr() {
		return $this->kontostand_ende_jahr;
	}
	
	public function get_summe_zinsanteile() {
		return $this->summe_zinsanteile;
	}
	
	//Setter: Set-Methoden übermitteln den Eigenschaftswert an ein Objektes der Klasse	
	public function set_finanzierungsbedarf($pFinanzierungsbedarf) {
		$this->finanzierungsbedarf = $pFinanzierungsbedarf;
	}
	
	public function set_zinssatz($pZinssatz) {
		$this->zinssatz = $pZinssatz;
	}
		
	public function set_tilgungssatz($pTilgungssatz) {
		$this->tilgungssatz = $pTilgungssatz;
	}
	
	public function set_zeitraum($pZeitraum) {
		$this->zeitraum = $pZeitraum;
	}	
	
	public function set_jahr($pJahr) {
		$this->jahr = $pJahr;
	}
	
	public function set_kreditbetrag($pKreditbetrag) {
		$this->kreditbetrag = $pKreditbetrag;
	}
	
	public function set_zinsanteil_jahr($pZinsanteil_jahr) {
		$this->zinsanteil_jahr = $pZinsanteil_jahr;
	}
	
	public function set_tilgung_jahr($pTilgung_jahr) {
		$this->tilgung_jahr = $pTilgung_jahr;
	}
	
	public function set_belastung_monat($pBelastung_monat) {
		$this->belastung_monat = $pBelastung_monat;
	}
	
	public function set_belastung_jahr($pBelastung_jahr) {
		$this->belastung_jahr = $pBelastung_jahr;
	}
	
	public function set_kontostand_ende_jahr($pKontostand_ende_jahr) {
		$this->kontostand_ende_jahr = $pKontostand_ende_jahr;
	}
	
	public function set_summe_zinsanteile($pSumme_zinsanteile) {
		$this->summe_zinsanteile = $pSumme_zinsanteile;
	}
	
		
	//Verhaltensweisen: Sonstige Methoden
	public function berechne_Annuitaet() {
		$mAnnuitaet = $this -> finanzierungsbedarf * ($this -> zinssatz + $this -> tilgungssatz)/100;
		$this -> set_ergebnis($mAnnuitaet);
	}			
	
	public function ermittle_Kreditbetrag(){
		if($this -> jahr == 1){
			$mKreditbetrag = $this -> finanzierungsbedarf;
			$this -> set_kreditbetrag($mKreditbetrag);
		}else{
			$mKreditbetrag = $this -> kontostand_ende_jahr;
			$this -> set_kreditbetrag($mKreditbetrag);
		}		
	}	
	
	public function berechne_Zinsanteil() {
			$mZinsanteil = $this -> kreditbetrag * $this -> zinssatz /100;
			$this -> set_zinsanteil_jahr($mZinsanteil);		
	}
	
	public function ermittle_Belastung_jahr() {
		$mBelastung_jahr = $this -> get_ergebnis();
		$this -> set_belastung_jahr($mBelastung_jahr);
	}
	
	public function berechne_Tilgung_jahr() {
		if($this -> jahr == 1){
			$mTilgung_jahr = 0;
		}else{
			$mTilgung_jahr = $this -> belastung_jahr - $this -> zinsanteil_jahr;			
		}
		$this -> set_tilgung_jahr($mTilgung_jahr);
	}	
	
	public function ermittle_Belastung_mon() {
		$mBelastung_mon = $this -> belastung_jahr/12;
		$this -> set_belastung_monat($mBelastung_mon);
	}	
				
	public function berechne_Kontostand_ende_jahr() {
		$mKontostand_ende_jahr = 0;
		if($this -> jahr == 1){
			$mKontostand_ende_jahr = $this -> kreditbetrag;
		}else{
			$mKontostand_ende_jahr = $this -> kontostand_ende_jahr - $this -> tilgung_jahr;			
		}
		$this -> set_kontostand_ende_jahr($mKontostand_ende_jahr);
	}	

	public function berechne_Zinsanteile_kummuliert() {
		$mSumme_zinsanteile = $this -> summe_zinsanteile + $this -> zinsanteil_jahr;
		$this -> set_summe_zinsanteile($mSumme_zinsanteile);
	}	
			
}
?>